package AStar_Prog;

import java.awt.Graphics;
import java.awt.Color;
import java.awt.Image;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.net.InterfaceAddress;
import java.net.Socket;
import java.net.SocketAddress;
import java.net.SocketException;

public class Main extends java.applet.Applet implements Runnable {

	static int currentX;
	static int currentY;

	static int squareX;
	static int squareY;

	static int[][] mySquares = new int[10][10];

	Thread runner;
	Image offscreenImg;
	Graphics offscreenG;

	public void init() {
		
		
		mySquares[0][0] = 2;
		
		
		this.setSize(500, 500);
		this.setMaximumSize(this.getSize());
		this.setMinimumSize(this.getSize());

		offscreenImg = createImage((int) this.getSize().getWidth(), (int) this.getSize().getWidth());
		offscreenG = offscreenImg.getGraphics();

		this.addMouseMotionListener(new MouseMotionListener() {

			@Override
			public void mouseMoved(MouseEvent e) {
				// TODO Auto-generated method stub

				currentX = e.getX();
				currentY = e.getY();

			}

			@Override
			public void mouseDragged(MouseEvent e) {
			}
		});

		this.addMouseListener(new MouseListener() {

			@Override
			public void mouseReleased(MouseEvent arg0) {
			}

			@Override
			public void mousePressed(MouseEvent e) {

			// Ziel oder Strae zurcksetzen
				for (int i = 0; i < mySquares.length; i++)
					for (int j = 0; j < mySquares[i].length; j++)
						if (mySquares[i][j] == 1 || mySquares[i][j] == 4) 
							mySquares[i][j] = 0;
				
				// neue Strae berechnen
				if (e.getButton() == MouseEvent.BUTTON1){	
				if (mySquares[squareX - 1][squareY - 1] != 2) {
				mySquares[squareX - 1][squareY - 1] = 1;
				
				mySquares[squareX-1][squareY-1] = 1;
				Map.findPath(mySquares);
				
				
				}
				// printFields();
			}
			else {
				//  Obstacle setzen
				if (mySquares[squareX - 1][squareY - 1] != 2)
					mySquares[squareX - 1][squareY - 1] = 3;
				
			}

			}

			@Override
			public void mouseExited(MouseEvent arg0) {
			}

			@Override
			public void mouseEntered(MouseEvent arg0) {
			}

			@Override
			public void mouseClicked(MouseEvent arg0) {
			}
		});

	}

	public void start() {

		if (runner == null)
			;
		{

			runner = new Thread(this);

			runner.start();

		}

	}

	public void stop() {

		if (runner != null) {

			runner.interrupt();

			runner = null;

		}

	}

	public void run() {

		while (true) {
			repaint();

			try {
				Thread.sleep(10);
			}

			catch (InterruptedException e) {
			}

		}

	}

	public void update(Graphics g) {
		paint(g);
	}

	public void paint(Graphics g) {

		offscreenG.setColor(Color.BLACK);

		for (int i = 0; i < 11; i++) {
			offscreenG.fillRect(50, i * 40 + 50, 403, 3);
			offscreenG.fillRect(i * 40 + 50, 50, 3, 400);
		}

		for (int i = 0; i < mySquares.length; i++)
			for (int j = 0; j < mySquares[i].length; j++) {
				if (mySquares[i][j] == 1) {
					offscreenG.setColor(Color.GREEN);
					offscreenG.fillRect((i + 1) * 40 + 13, (j + 1) * 40 + 13, 37, 37);
				}
				
				if (mySquares[i][j] == 4) {
					offscreenG.setColor(Color.DARK_GRAY);
					offscreenG.fillRect((i + 1) * 40 + 13, (j + 1) * 40 + 13, 37, 37);
				}
				
				if (mySquares[i][j] == 3) {
					offscreenG.setColor(Color.BLACK);
					offscreenG.fillRect((i + 1) * 40 + 13, (j + 1) * 40 + 13, 37, 37);
				}
		
				if (mySquares[i][j] == 2) {
					offscreenG.setColor(Color.BLUE);
					offscreenG.fillRect((i + 1) * 40 + 13, (j + 1) * 40 + 13, 37, 37);
				}
				if (mySquares[i][j] == 0) {
					offscreenG.setColor(Color.WHITE);
					offscreenG.fillRect((i + 1) * 40 + 13, (j + 1) * 40 + 13, 37, 37);
				}
			}
		
		offscreenG.setColor(Color.RED);

		squareX = 0;
		squareY = 0;

		do {
			squareX++;
		} while ((50 + squareX * 40) < currentX && squareX < 10);

		do {
			squareY++;
		} while ((50 + squareY * 40) < currentY && squareY < 10);

		offscreenG.fillRect((squareX) * 40 + 13, (squareY) * 40 + 13, 37, 37);

		g.drawImage(offscreenImg, 0, 0, this);

	}

	public void destroy() {

		offscreenG.dispose();

	}

	public static void printFields() {

		// 0 = Free
		// 1 = Target
		// 2 = Player
		// 3 = Obstacle
		// 4 = Road
		for (int i = 0; i < mySquares.length; i++) {
			System.out.println("");
			for (int j = 0; j < mySquares[i].length; j++)
				System.out.print(mySquares[j][i] + " ");
		}
		System.out.println("");
	}
	

}