package AStar_Prog;

import java.util.ArrayList;
import java.util.PriorityQueue;


/*
 * Anmerkungen
 * statt ClosedList Bool Variable in Knoten Speichern
 * statt Nachbarn einzeln abspeichern Liste erstellen
 * Knotenart in Knoten abspeichern, redundates int[][] auflsen
 */

public class Map {
	
	private static PriorityQueue<GraphNode> openNodes;
	private static ArrayList<GraphNode> closedNodes;
	private static ArrayList<GraphNode> buildList;
	
	private static int[][] map; 
	
	private static int playerX;
	private static int playerY;
	private static int targetX;
	private static int targetY;
	
	public static int getTargetX() {
		return targetX;
	}

	public static void setTargetX(int targetX) {
		Map.targetX = targetX;
	}

	public static int getTargetY() {
		return targetY;
	}

	public static void setTargetY(int targetY) {
		Map.targetY = targetY;
	}
	
	public static int[][] getMap() {
		return map;
	}

	public static void setMap(int[][] map) {
		Map.map = map;
	}


	static GraphNode targetNode;
	static GraphNode playerNode;
	
	public static void buildMap() {
			
		buildList = new ArrayList<GraphNode>();
		
		for(int i=0; i<10; i++)
			for(int j=0; j<10; j++)
			buildList.add(new GraphNode(i, j));
		
		for(int i=0; i<90; i++) {
			buildList.get(i).setSouth(buildList.get(i+10));
		}
		
		for(int i=10; i<100; i++) {
			buildList.get(i).setNorth(buildList.get(i-10));
		}
		
		for(int i=0; i<100; i++) {
			if(i%10 != 0)
			buildList.get(i).setWest(buildList.get(i-1));
		}
		
		for(int i=0; i<100; i++) {
			if(i%10 != 9)
			buildList.get(i).setEast(buildList.get(i+1));
		}
		
	}
	
	public static void findPath(int[][] map){
		
		
		System.out.println(map == Main.mySquares);
		
		
		long time = System.nanoTime();
		
		setMap(map);
		
		if(buildList == null)
			buildMap();
		
		for(GraphNode n: buildList)
			n.reset();		
		
		
		
		// Target wird gesucht!
		for (int i = 0; i < 10; i++){
			for (int j = 0; j < 10; j++){
			
		if(map[i][j] == 1){
			targetX = i;
			targetY = j;
		}
		}
		}
		
		
		// Player wird gesucht!
		for (int i = 0; i < 10; i++){
			for (int j = 0; j < 10; j++){
			
		if(map[i][j] == 2){
			playerX = i;
			playerY = j;
		}
		}
		}

		playerNode = buildList.get(playerX*10 + playerY);
	    targetNode = buildList.get(10*targetX+targetY);
		
	    
	    
	    openNodes = new PriorityQueue<GraphNode>();
		closedNodes = new ArrayList<GraphNode>();
		
		GraphNode startNode = buildList.get(playerX*10 + playerY);
		startNode.setDistance(0);
		
		openNodes.add(startNode);
		
		GraphNode tmp;
		
		int i = 0;
		
		while(!openNodes.isEmpty()) {
			
			i++;
		 
			tmp = openNodes.poll();	
			
			if(tmp == targetNode)
				break;
			
			addFriends(tmp);
			
		}
		
		
		GraphNode tmp2 = targetNode.getHome();
		if (tmp2 != null) {
		while(tmp2 != playerNode) {
			map[tmp2.getX()][tmp2.getY()] = 4;
			tmp2 = tmp2.getHome();
		}
		}
		
		
		System.out.println("Nodes checked: " + i);
		System.out.println("Time needed (s): " + (System.nanoTime() - time) / 1000);
		
		
	}
	

	

	public static void addFriends(GraphNode node) {
		
		closedNodes.add(node);
		
		GraphNode north = node.getNorth();
		GraphNode south = node.getSouth();
		GraphNode west = node.getWest();
		GraphNode east = node.getEast();
		
		if(north != null && !closedNodes.contains(north) && north.isValid()) {
			if (node.getDistance() + 1 < north.getDistance()) {
				north.setHome(node);
				north.calculateDistance();
				north.calculateFitness();
			}
			if(!openNodes.contains(north))
			openNodes.add(north);
		}

		if(south != null  && !closedNodes.contains(south) && south.isValid()) {
				if (node.getDistance() + 1 < south.getDistance()) {
					south.setHome(node);
					south.calculateDistance();
					south.calculateFitness();
				}
				if(!openNodes.contains(south))
				openNodes.add(south);
			}
		
		if(west != null  && !closedNodes.contains(west) && west.isValid()) {
				if (node.getDistance() + 1 < west.getDistance()) {
					west.setHome(node);
					west.calculateDistance();
					west.calculateFitness();
				}
				if(!openNodes.contains(west))
				openNodes.add(west);
			}

		if(east != null  && !closedNodes.contains(east) && east.isValid()) {
				if (node.getDistance() + 1 < east.getDistance()) {
					east.setHome(node);
					east.calculateDistance();
					east.calculateFitness();
				}
				if(!openNodes.contains(east))
				openNodes.add(east);
			}	
		
	}
}
